import Hash from "../../utils/hash";

var jsonLogic = require("json-logic-js");

export default {
  data: function() {
    return {
      _shouldShow: false,
    };
  },
  computed: {
    display() {
      return this.$data._shouldShow ? "block" : "none"
    }
  },
  methods: {
    // TODO: Deprecated
    genericStyles(spec) {
      return this.$styles(spec)
    },
    $styles(spec) {
      const properties = spec || this.spec;
      const styles = {
        color: properties.color,
        "background-color": properties.backgroundColor,
        "text-align": properties.textAlign
      };

      const padding = properties.padding;
      if (Utils.type.isObject(padding)) {
        Utils.type.ifNumber(
          padding.top,
          top => (styles["padding-top"] = `${top}px`)
        );
        Utils.type.ifNumber(
          padding.bottom,
          bottom => (styles["padding-bottom"] = `${bottom}px`)
        );
        Utils.type.ifNumber(
          padding.left,
          left => (styles["padding-left"] = `${left}px`)
        );
        Utils.type.ifNumber(
          padding.right,
          right => (styles["padding-right"] = `${right}px`)
        );
      }

      Utils.type.ifString(
        this.$length(properties.width),
        val => (styles["width"] = val)
      );
      Utils.type.ifString(
        this.$length(properties.height),
        val => (styles["height"] = val)
      );

      Utils.type.ifObject(
        properties.onClick,
        val => (styles["cursor"] = "pointer")
      );

      this.__display(styles, properties);

      return new Hash(styles);
    },
    __display(styles, properties) {
      Utils.type.ifObject(
        properties.showIf,
        val => (styles["display"] = this.display)
      );
    },
    $classes(spec) {
      const properties = spec || this.spec;
      const componentName = Utils.app.componentName(properties.view);
      const classes = (properties.styleClasses || []).concat(componentName);

      Utils.type.ifArray(properties.styleClasses, val => {
        if (val.includes("card")) {
          classes.push("v-card");
          classes.push("v-sheet");
          classes.push("theme--light");

          if (val.includes("outlined")) {
            classes.push("v-card--outlined");
          }
        }
      });
      return classes;
    },
  }
};
